VERSION 5.00
Begin VB.UserControl DBImage 
   Alignable       =   -1  'True
   AutoRedraw      =   -1  'True
   ClientHeight    =   2532
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2748
   DataBindingBehavior=   1  'vbSimpleBound
   ScaleHeight     =   2532
   ScaleWidth      =   2748
   ToolboxBitmap   =   "DBImage.ctx":0000
   Begin VB.Image img 
      BorderStyle     =   1  'Fixed Single
      Height          =   1668
      Left            =   0
      Stretch         =   -1  'True
      Top             =   0
      Width           =   1812
   End
   Begin VB.Menu mnu 
      Caption         =   ""
      Begin VB.Menu mnuCut 
         Caption         =   "Cu&t"
      End
      Begin VB.Menu mnuCopy 
         Caption         =   "&Copy"
      End
      Begin VB.Menu mnuPaste 
         Caption         =   "&Paste"
      End
      Begin VB.Menu mnuSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuDelete 
         Caption         =   "&Delete"
      End
   End
End
Attribute VB_Name = "DBImage"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' Image Field Control - DBImage.ocx
' By Amit Banore, Email:amit.banore@in.commerzbank.com
' This one is component that allows you to populate image data from a ADO field to the component just like you would populate a text field with text data from a text field.
'
' The component has a default property Photofield which can be used to hold data from a image field in a ADO recordset.
' For eg. if you have an instance of the DBImage on a form named as DBImage1 and rs as a open recordset containing the image field 'Photo', then you can use :
'   DBImage1.PhotoField = rs("Photo") - This will populate the control and display the image
'   rs("Photo") = DBIMage1.PhototField - This will update the Image field from the image stored in the Control
' You can load a image file into the component using its LoadImage method which is similar to the LoadPicyture method of Image/Picture Control,
' The Control also exposes a context menu which can be enabled by the RightClickMenu property
' The NoImage property holds a image selected by the developer that shows up when PhotoField is empty
'
' Also the control can be binded to a ADO control/Data Environment with the PhotoField property as the binding property.

Option Explicit


Private Declare Function GetTempPathA Lib "kernel32" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
    
Private Declare Function GetTempFileNameA Lib "kernel32" (ByVal lpszPath As String, ByVal lpPrefixString As String, ByVal wUnique As Long, ByVal lpTempFileName As String) As Long
     
Private Const UNIQUE_NAME = &H0

Public Enum AppearanceValues
    Flat = 0
    ThreeD = 1
End Enum
Public Enum BorderStyleValues
    None = 0
    FixedSingle = 1
End Enum

Private pNoImage As New StdPicture, bNoImage As Boolean, pRightClickMenu As Boolean

Public Event Click()
Attribute Click.VB_MemberFlags = "200"
Public Event MouseMove(Button%, Shift%, X As Single, Y As Single)
Public Event MouseUp(Button%, Shift%, X As Single, Y As Single)
Public Event MouseDown(Button%, Shift%, X As Single, Y As Single)
Public Event DblClick()

Private Function AddBackslash$(s$)

   If Len(s) > 0 Then
      If Right$(s, 1) <> "\" Then
         AddBackslash = s + "\"
      Else
         AddBackslash = s
      End If
   Else
      AddBackslash = "\"
   End If

End Function
Public Property Get NoImage() As StdPicture
Attribute NoImage.VB_Description = "Select Image file to display for NULL data"
Attribute NoImage.VB_ProcData.VB_Invoke_Property = ";Appearance"
    Set NoImage = pNoImage
End Property

Public Property Set NoImage(ByVal f As StdPicture)
    Set pNoImage = f
    PropertyChanged "NOIMG"
End Property

Private Function GetTempPath$()
  
   Dim sTmp$, I%

   I = GetTempPathA(0, "")
   sTmp = Space(I)

   Call GetTempPathA(I, sTmp)
   GetTempPath = AddBackslash(Left$(sTmp, I - 1))
End Function

Private Function GetTempFileName$()

   Dim sTmp$, sTmp2$

   sTmp2 = GetTempPath
   sTmp = Space(Len(sTmp2) + 256)
   Call GetTempFileNameA(sTmp2, App.EXEName, UNIQUE_NAME, sTmp)
   GetTempFileName = Left$(sTmp, InStr(sTmp, Chr$(0)) - 1)
End Function

Private Sub img_Click()
    RaiseEvent Click
End Sub

Private Sub img_DblClick()
    RaiseEvent DblClick
End Sub

Private Sub img_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

Private Sub img_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub


Private Sub img_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Not RightClickMenu Then
        RaiseEvent MouseUp(Button, Shift, X, Y)
    ElseIf (Button And vbRightButton) = vbRightButton Then
        PopupMenu mnu
    End If
End Sub


Private Sub mnuCopy_Click()
    Clipboard.Clear
    Clipboard.SetData img.Picture, vbCFDIB
End Sub


Private Sub mnuCut_Click()
    mnuCopy_Click
    mnuDelete_Click
End Sub

Private Sub mnuDelete_Click()
    LoadImage
End Sub

Private Sub mnuPaste_Click()
    bNoImage = False
    img.Picture = Clipboard.GetData(vbCFDIB)
    PropertyChanged "IMG"
End Sub

Private Sub UserControl_Initialize()
    bNoImage = True
End Sub

Private Sub UserControl_InitProperties()
    Appearance = ThreeD
    BorderStyle = FixedSingle
End Sub
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    Appearance = PropBag.ReadProperty("APPEARANCE", 1)
    BorderStyle = PropBag.ReadProperty("BORDERSTYLE", 1)
    PhotoField = PropBag.ReadProperty("IMG", Null)
    Set NoImage = PropBag.ReadProperty("NOIMG", Nothing)
    RightClickMenu = PropBag.ReadProperty("RIGHTCLICKMENU", True)
End Sub


Private Sub UserControl_Resize()
    img.Width = UserControl.ScaleWidth
    img.Height = UserControl.ScaleHeight
End Sub




Public Property Get PhotoField()
Attribute PhotoField.VB_ProcData.VB_Invoke_Property = ";Data"
Attribute PhotoField.VB_MemberFlags = "264"
Dim rs As ADODB.Recordset, FileNum%, Buffer() As Byte, BytesNeeded&, Buffers&, Remainder&, r%, I&, FileName$
Const CHUNKSIZE = 1048576

    If img.Picture = 0 Or bNoImage Then
        PhotoField = Null
        Exit Property
    End If
    FileName = GetTempFileName()
    SavePicture img.Picture, FileName
    FileNum = FreeFile
    Open FileName For Binary As #FileNum
    BytesNeeded = LOF(FileNum)
    Buffers = BytesNeeded \ CHUNKSIZE
    Remainder = BytesNeeded Mod CHUNKSIZE
    Set rs = New ADODB.Recordset
    rs.Fields.Append "ImgHolder", adVarBinary, BytesNeeded, adFldUpdatable + adFldLong
    rs.Open
    rs.AddNew
    For I = 0 To Buffers - 1
        ReDim Buffer(CHUNKSIZE)
        Get #FileNum, , Buffer
        rs("ImgHolder").AppendChunk Buffer
    Next I
    If Remainder > 0 Then
        ReDim Buffer(CHUNKSIZE)
        Get #FileNum, , Buffer
        rs("ImgHolder").AppendChunk Buffer
    End If
    Close #FileNum
    Kill FileName
    PhotoField = rs("ImgHolder").Value
End Property
Public Property Let PhotoField(ByVal f)
On Error GoTo ErrorHandler
Dim FileNum%, Buffer() As Byte, BytesNeeded&, Buffers&, Remainder&, r%, I&, FileName$
Const CHUNKSIZE = 1048576

    bNoImage = True
    Set img.Picture = NoImage
    BytesNeeded = LenB(f) 'f.ActualSize
    If BytesNeeded = 0 Then Exit Property
    Buffers = BytesNeeded \ CHUNKSIZE
    Remainder = BytesNeeded Mod CHUNKSIZE
    FileName = GetTempFileName()
    FileNum = FreeFile
    Open FileName For Binary As #FileNum
    For I = 0 To Buffers - 1
        ReDim Buffer(CHUNKSIZE)
        Buffer = MidB(f, CHUNKSIZE * I + 1, CHUNKSIZE) 'f.GetChunk(CHUNKSIZE)
        Put #FileNum, , Buffer()
    Next I
    If Remainder > 0 Then
        ReDim Buffer(Remainder)
        Buffer = MidB(f, CHUNKSIZE * I + 1, Remainder) 'f.GetChunk(Remainder)
        Put #FileNum, , Buffer()
    End If
    Close #FileNum
    bNoImage = False
    img.Picture = LoadPicture(FileName)
    Kill FileName
    PropertyChanged "IMG"
    Exit Property
ErrorHandler:
    On Error GoTo 0
End Property
Public Property Get Appearance() As AppearanceValues
Attribute Appearance.VB_ProcData.VB_Invoke_Property = ";Appearance"
    Appearance = img.Appearance
End Property

Public Property Let Appearance(ByVal vNewValue As AppearanceValues)
    img.Appearance = vNewValue
    PropertyChanged "APPEARANCE"
End Property

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty "APPEARANCE", Appearance, 1
    PropBag.WriteProperty "BORDERSTYLE", BorderStyle, 1
    PropBag.WriteProperty "IMG", PhotoField, Null
    PropBag.WriteProperty "NOIMG", NoImage, Nothing
    PropBag.WriteProperty "RIGHTCLICKMENU", pRightClickMenu, True
End Sub
Public Property Get BorderStyle() As BorderStyleValues
Attribute BorderStyle.VB_ProcData.VB_Invoke_Property = ";Appearance"
    BorderStyle = img.BorderStyle
End Property

Public Property Let BorderStyle(ByVal vNewValue As BorderStyleValues)
    img.BorderStyle = vNewValue
    PropertyChanged "BORDERSTYLE"
End Property

Public Sub LoadImage(Optional ByVal f)
On Error GoTo ErrorHandler
    If Not IsMissing(f) Then
        img.Picture = LoadPicture(f)
        bNoImage = False
    Else
        bNoImage = True
        Set img.Picture = NoImage
    End If
    PropertyChanged "IMG"
    Exit Sub
ErrorHandler:
    On Error GoTo 0
End Sub


Public Property Get RightClickMenu() As Boolean
Attribute RightClickMenu.VB_Description = "Enable Right click context menu"
Attribute RightClickMenu.VB_ProcData.VB_Invoke_Property = ";Behavior"
    RightClickMenu = pRightClickMenu
End Property

Public Property Let RightClickMenu(ByVal vNewValue As Boolean)
    pRightClickMenu = vNewValue
    PropertyChanged "RIGHTCLICKMENU"
End Property
